org.eclipse.viatra.query.runtime.rete.matcher

## Class TimelyReteBackendFactory

- java.lang.Object
- - org.eclipse.viatra.query.runtime.rete.matcher.ReteBackendFactory
  - - org.eclipse.viatra.query.runtime.rete.matcher.TimelyReteBackendFactory

- All Implemented Interfaces:
    IQueryBackendFactory

      public class TimelyReteBackendFactory
      extends ReteBackendFactory

  A `ReteBackendFactory` implementation that creates `ReteEngine`s that use non-scattered timely evaluation.
  Since:
    2.4

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static TimelyReteBackendFactory` | `FAITHFUL_PARALLEL`
    `static TimelyReteBackendFactory` | `FAITHFUL_SEQUENTIAL`
    `static TimelyReteBackendFactory` | `FIRST_ONLY_PARALLEL`
    `static TimelyReteBackendFactory` | `FIRST_ONLY_SEQUENTIAL`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.matcher.ReteBackendFactory

      `INSTANCE, reteThreads`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimelyReteBackendFactory(TimelyConfiguration configuration)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IQueryBackend` | `create(IQueryBackendContext context)` Creates a new `IQueryBackend` instance tied to the given context elements.
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.matcher.ReteBackendFactory

      `calculateRequiredCapability, create, getBackendClass, isCaching`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FIRST_ONLY_SEQUENTIAL

          public static final TimelyReteBackendFactory FIRST_ONLY_SEQUENTIAL

    - #### FIRST_ONLY_PARALLEL

          public static final TimelyReteBackendFactory FIRST_ONLY_PARALLEL

    - #### FAITHFUL_SEQUENTIAL

          public static final TimelyReteBackendFactory FAITHFUL_SEQUENTIAL

    - #### FAITHFUL_PARALLEL

          public static final TimelyReteBackendFactory FAITHFUL_PARALLEL

  - ### Constructor Detail

    - #### TimelyReteBackendFactory

          public TimelyReteBackendFactory(TimelyConfiguration configuration)

  - ### Method Detail

    - #### create

          public IQueryBackend create(IQueryBackendContext context)

      Description copied from interface: `IQueryBackendFactory`
      Creates a new `IQueryBackend` instance tied to the given context elements.
      Specified by:
        `create` in interface `IQueryBackendFactory`
      Overrides:
        `create` in class `ReteBackendFactory`
      Returns:
        an instance of the class returned by `IQueryBackendFactory.getBackendClass()` that operates in the given context.

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `ReteBackendFactory`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `ReteBackendFactory`